#include <match_icmp.h>
#include <s_util.h>

proc_print_out		print_out;
proc_print_raw		print_raw;
proc_matcher_add	add_matcher;

#define CHECK_ICMP(x) \
	(( x->layer[LAYER_NET].id == 0x0800 ) ? 1 : 0) && \
	(( x->layer[LAYER_TRANS].id == IPPROTO_ICMP ) ? 1 : 0)

int icmp_id_match(void *priv, p_packet p, int negate)
{
	ushort id;
	p_range_priv x=(p_range_priv)priv;
	
	if ( !CHECK_ICMP(p) ) return 0;

	id = ntohs(p->layer[LAYER_TRANS].h.icmp->un.echo.id);

	if ( (id >= x->min) && (id <= x->max) ) {
		MATCH_RET_POSITIVE;
	}else{
		MATCH_RET_NEGATIVE;
	}
}

int icmp_seq_match(void *priv, p_packet p, int negate)
{
	ushort seq;
	p_range_priv x=(p_range_priv)priv;
	
	if ( !CHECK_ICMP(p) ) return 0;

	seq = ntohs(p->layer[LAYER_TRANS].h.icmp->un.echo.sequence);

	if ( (seq >= x->min) && (seq <= x->max) ) {
		MATCH_RET_POSITIVE;
	}else{
		MATCH_RET_NEGATIVE;
	}
}

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);

	print_out=in->print_out;
	print_raw=in->print_raw;
	add_matcher=in->add_matcher;

	out->name="match/icmp";
	out->desc="Generic matches for ICMP packets";
	out->ver_major=1;
	out->ver_minor=0;
	
	add_matcher("ICMP_ID",
		in->templates.t_validate_range,
		in->templates.t_cleanup_ptr,
		icmp_id_match);

	add_matcher("ICMP_SEQ",
		in->templates.t_validate_range,
		in->templates.t_cleanup_ptr,
		icmp_seq_match);
	
	return PLUGIN_ERR_OK;
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}
