#include <link.h>

proc_print_out print_out;
proc_print_raw print_raw;
proc_demux_add_handler add_demux;

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);

	print_out=in->print_out;
	print_raw=in->print_raw;
	add_demux=in->add_demux;

	out->name="proto/link";
	out->desc="Some of the more popular data link protocols";
	out->ver_major=1;
	out->ver_minor=0;
	
	if ( !(add_demux(LAYER_LINK, demux_callback)) ) {
		return PLUGIN_ERR_FAIL;
	}else{	
		return PLUGIN_ERR_OK;
	}
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}

/* This is our actual demultiplex handler */
#define NPROTO_IP	0x0800
demux_pret_t demux_callback(p_packet p)
{
	if ( !p->layer[LAYER_LINK].h.raw ) return;

	switch (p->layer[LAYER_LINK].id) {
		case NULL:
		case DLT_RAW:
			p->layer[LAYER_LINK].name = "Raw IP";
			p->layer[LAYER_NET].h.raw = &p->data;
			p->layer[LAYER_NET].id = NPROTO_IP;
			return DEMUX_SKIP;

		case DLT_EN10MB:
			p->layer[LAYER_LINK].name = "Ethernet II";
			p->layer[LAYER_NET].id = 
				ntohs(p->layer[LAYER_LINK].h.mac->h_proto);
			p->layer[LAYER_NET].h.raw = p->layer[LAYER_LINK].h.raw
			       + sizeof(struct ethhdr);
			//print_out("MAC type: %.4x" CRLF, p->layer[LAYER_NET].id);	
			return DEMUX_SKIP;
		
		default:
			return DEMUX_NULL;
	}

	return DEMUX_NULL;
}
